---
title: 'TypeError: invalid assignment to const "x"'
slug: Web/JavaScript/Reference/Errors/Invalid_const_assignment
tags:
  - Error
  - JavaScript
  - TypeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "invalid assignment to const" occurs when it was attempted to alter a constant value. JavaScript <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/const">const</a></code> declarations can't be re-assigned or redeclared.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">TypeError: invalid assignment to const "x" (Firefox)
TypeError: Assignment to constant variable. (Chrome)
TypeError: Assignment to const (Edge)
TypeError: Redeclaration of const 'x' (IE)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("TypeError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>A constant is a value that cannot be altered by the program during normal execution. It cannot change through re-assignment, and it can't be redeclared. In JavaScript, constants are declared using the <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/const">const</a></code> keyword.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Invalid_redeclaration">Invalid redeclaration</h3>

<p>Assigning a value to the same constant name in the same block-scope will throw.</p>

<pre class="brush: js example-bad">const COLUMNS = 80;

// ...

COLUMNS = 120; // TypeError: invalid assignment to const `COLUMNS'</pre>

<h3 id="Fixing_the_error">Fixing the error</h3>

<p>There are multiple options to fix this error. Check what was intended to be achieved with the constant in question.</p>

<h4 id="Rename">Rename</h4>

<p>If you meant to declare another constant, pick another name and re-name. This constant name is already taken in this scope.</p>

<pre class="brush: js example-good">const COLUMNS = 80;
const WIDE_COLUMNS = 120;</pre>

<h4 id="const_let_or_var"><code>const</code>, <code>let</code> or <code>var</code>?</h4>

<p>Do not use const if you weren't meaning to declare a constant. Maybe you meant to declare a block-scoped variable with <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/let">let</a></code> or global variable with <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/var">var</a></code>.</p>

<pre class="brush: js example-good">let columns = 80;

// ...

let columns = 120;
</pre>

<h4 id="Scoping">Scoping</h4>

<p>Check if you are in the correct scope. Should this constant appear in this scope or was it meant to appear in a function, for example?</p>

<pre class="brush: js example-good">const COLUMNS = 80;

function setupBigScreenEnvironment() {
  const COLUMNS = 120;
}</pre>

<h3 id="const_and_immutability"><code>const</code> and immutability</h3>

<p>The <code>const</code> declaration creates a read-only reference to a value. It does <strong>not</strong> mean the value it holds is immutable, just that the variable identifier cannot be reassigned. For instance, in case the content is an object, this means the object itself can still be altered. This means that you can't mutate the value stored in a variable:</p>

<pre class="brush: js example-bad">const obj = {foo: 'bar'};
obj = {foo: 'baz'}; // TypeError: invalid assignment to const `obj'
</pre>

<p>But you can mutate the properties in a variable:</p>

<pre class="brush: js example-good">obj.foo = 'baz';
obj; // Object { foo: "baz" }</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/const">const</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/let">let</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/var">var</a></code></li>
</ul>
